package ru.windcorp.turretlang;

import ru.windcorp.turretlang.saveable.TLSaveable;

public class TLWrittableVariable extends TLVariable {

	public TLWrittableVariable(String initalDeclar) throws TLException {
		super(initalDeclar);
	}
	
	public void setValue(String arg0) {
		if (arg0 != null) {
			super.value = arg0;
			super.declaration = TurretLang.createDeclaration(getName(), arg0);
		}
	}
	
	public void setName(String arg0) {
		if (arg0 != null) {
			super.name = arg0;
			super.declaration = TurretLang.createDeclaration(arg0, getValue());
		}
	}
	
	public void setDeclaration(String arg0) throws TLException {
		if (arg0 != null) {
			super.declaration = arg0;
			super.name = TurretLang.getVariableName(arg0);
			super.value = TurretLang.getVariableValue(arg0);
		}
	}
	
	public void setValue(int arg0) {
		setValue(String.valueOf(arg0));
	}
	
	public void setValue(byte arg0) {
		setValue(String.valueOf(arg0));
	}
	
	public void setValue(short arg0) {
		setValue(String.valueOf(arg0));
	}
	
	public void setValue(long arg0) {
		setValue(String.valueOf(arg0));
	}
	
	public void setValue(float arg0) {
		setValue(String.valueOf(arg0));
	}
	
	public void setValue(double arg0) {
		setValue(String.valueOf(arg0));
	}
	
	public void setValue(TLSaveable arg0) {
		if (arg0 == null) setValue("~null");
			
		StringBuilder sb = new StringBuilder();
		sb.append(arg0.getClass().getName()).append("*");
		for (String s : arg0.toTLString()) {
			sb.append(s).append("*");
		}
		
		setValue(sb.toString());
	}
	
}
