package ru.windcorp.turretlang.saveable;

public class TLSaveableException extends Exception {
	private static final long serialVersionUID = 4874521813892021114L;
	private final String failedDeclar;
	
	public TLSaveableException(String failedDeclar) {
		this.failedDeclar = failedDeclar;
	}

	public TLSaveableException(String message, String failedDeclar) {
		super(message);
		this.failedDeclar = failedDeclar;
	}

	public TLSaveableException(Throwable cause, String failedDeclar) {
		super(cause);
		this.failedDeclar = failedDeclar;
	}

	public TLSaveableException(String message, Throwable cause, String failedDeclar) {
		super(message, cause);
		this.failedDeclar = failedDeclar;
	}

	public TLSaveableException(String message, Throwable cause, boolean enableSuppression, boolean writableStackTrace, String failedDeclar) {
		super(message, cause, enableSuppression, writableStackTrace);
		this.failedDeclar = failedDeclar;
	}
	
	public String getDeclaration() {
		return this.failedDeclar;
	}

}
